#include <iostream>
#include <future>

using namespace std;

int multiply(int input1, int input2) {
    cout << "In multiply function, thread id: " << this_thread::get_id() << endl;
    return input1 * input2;
}

int main() {
    int input1 = 10;
    int input2 = 5;

    cout << "The main thread id " << this_thread::get_id() << endl;

    cout << "Async with launch::async" << endl;
    future<int> eagerAsyncResult = async(launch::async, multiply, input1, input2);
    eagerAsyncResult.get();

    cout << "Async with launch::deferred" << endl;
    future<int> lazyAsyncResult = async(launch::deferred, multiply, input1, input2);
    lazyAsyncResult.get();  // Try to comment this line, what will happen?

    return 0;
}

